#
# spec file for package tomcat5 (Version 5.0.30)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    Xalan-c Xerces-c aaa_base acl ant ant-trax attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison brp-check-internal bzip2 coreutils cpio cpp cpp41 cracklib cryptix cryptix-asn1 cvs cyrus-sasl db diffutils e2fsprogs expat file filesystem fillup findutils flex fontconfig gawk gcc gcc41 gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv jaf jakarta-commons-beanutils jakarta-commons-collections jakarta-commons-daemon jakarta-commons-dbcp jakarta-commons-digester jakarta-commons-el jakarta-commons-fileupload jakarta-commons-launcher jakarta-commons-logging jakarta-commons-modeler jakarta-commons-pool jakarta-commons-validator jakarta-taglibs-standard java-1_5_0-sun java-1_5_0-sun-devel javamail jpackage-utils jta junit klogd less libacl libattr libcom_err libgcc41 libicu libltdl libmudflap41 libnscd libstdc++41 libtool libvolume_id libxcrypt libxml2 libzio linux-kernel-headers log4j m4 make man mktemp module-init-tools mx4j ncurses ncurses-devel net-tools netcfg openldap2-client openssl oro pam pam-modules patch perl permissions popt post-build-checks procinfo procps psmisc puretls pwdutils rcs readline regexp rpm sed servletapi5 sgml-skel strace struts sysvinit tar tcpd texinfo timezone unzip update-alternatives util-linux vim xalan-j2 xerces-j2 xml-commons xml-commons-apis xorg-x11-libICE xorg-x11-libSM xorg-x11-libX11 xorg-x11-libXau xorg-x11-libXdmcp xorg-x11-libXext xorg-x11-libXfixes xorg-x11-libXmu xorg-x11-libXp xorg-x11-libXpm xorg-x11-libXprintUtil xorg-x11-libXrender xorg-x11-libXt xorg-x11-libXv xorg-x11-libfontenc xorg-x11-libs xorg-x11-libxkbfile zlib zlib-devel


Name:           tomcat5
BuildRequires:  Xalan-c ant-trax jaf jakarta-commons-daemon jakarta-commons-dbcp jakarta-commons-el jakarta-commons-launcher jakarta-commons-modeler jakarta-taglibs-standard java-1_5_0-sun-devel javamail jta junit log4j mx4j puretls regexp struts unzip update-alternatives
#BuildRequires: build_xml_helper
%define full_name	jakarta-%{name}
%define majversion	5.0
%define section		free
%define jname		jasper5
%define tcuid		91
%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src
# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
# tomcat lives in /usr/share/tomcat5
%define homedir		%{_datadir}/%{name}
# unchangeable stuff below %{homedir}
%define bindir		%{homedir}/bin
%define serverdir	%{homedir}/server
%define commondir	%{homedir}/common
%define shareddir	%{homedir}/shared
# symlinks to all directories and symlinks in default 
# CATLAINA_BASE (see below) will be created so that tomcat can be
# started with no CATALINA_BASE set and CATALINA_HOME pointing to
# %{homedir}
# default CATALINA_BASE in /srv/www/tomcat5/base
%define catalina_base   /srv/www/%{name}/base
%define appdir		%{catalina_base}/webapps
# symlinks from %{catalina_base} to these will be created
%define confdir		%{_sysconfdir}/%{name}/base
%define logdir		%{_localstatedir}/log/%{name}/base
%define tempdir		%{_localstatedir}/cache/%{name}/base/temp
%define workdir		%{_localstatedir}/cache/%{name}/base/work
Summary:        A servlet container
Version:        5.0.30
Release:        67
License:        BSD 3-Clause; The Apache Software License; X11/MIT; zlib/libpng License
Group:          Productivity/Networking/Web/Frontends
Url:            http://jakarta.apache.org
BuildArch:      noarch
Source:         http://jakarta.apache.org/builds/jakarta-tomcat-5.0/release/v%{version}/src/%{packdname}.tar.gz
Source8:        %{name}-%{majversion}.logrotate
Source9:        %{name}-%{majversion}.relink
Source10:       %{name}-%{majversion}-addons.tar.bz2
Patch1:         tomcat5-%{version}.patch
Patch2:         %{name}-%{majversion}.link_admin_jar.patch
Patch3:         %{name}-%{version}-no-jsvc-tar.patch
Patch4:         %{name}-%{version}-cluster-pathelement.patch
Patch5:         %{name}-%{version}-skip-build-on-install.patch
Patch6:         %{name}-%{version}-javaxssl.patch
Patch7:         %{jname}_command.patch
Patch8:         %{name}-%{version}-bootstrap.MF.patch
Patch9:         %{name}-%{version}-catalina.sh.patch
# Patch10 for #113319, see
# http://forum.java.sun.com/thread.jspa?threadID=624292&tstart=0
Patch10:        %{name}-%{version}-struts-config.patch
Patch11:        %{name}-%{version}-server_xml-log_config.patch
Patch12:        %{name}_build150.patch
Patch150:       %{name}_javac_source_target.patch
Patch13:        %{name}-%{version}-CVE-2007-0450-backport.patch
Patch14:        %{name}-%{version}-CVE-2006-7195.patch
Patch15:        jakarta-tomcat-CVE-2006-7196.patch
Patch16:        jakarta-tomcat-CVE-2007-3382.patch
Patch17:        jakarta-tomcat-CVE-2007-3385.patch
Patch18:        jakarta-tomcat-CVE-2007-5461.patch
Patch19:        jakarta-tomcat-CVE-2008-0128.patch
Patch20:        jakarta-tomcat-CVE-2005-2090.patch
Patch21:        jakarta-tomcat-CVE-2007-5333.patch
Patch22:        jakarta-tomcat-CVE-2007-1858.patch
Patch23:        jakarta-tomcat-CVE-2007-2449.patch
Patch24:        jakarta-tomcat-CVE-2007-2450.patch
Patch25:        jakarta-tomcat-CVE-2008-2370.patch
Patch26:        jakarta-tomcat-CVE-2008-1232.patch
Patch27:        jakarta-tomcat-CVE-2008-2938.patch
Patch28:        jakarta-tomcat-CVE-2008-3271.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
PreReq:         ant, jpackage-utils >= 1.5.24
Requires:       ant-trax
Requires:       log4j >= 1.2
# xml parsing - isn't this already required by ant ?
PreReq:         xerces-j2 >= 2.6.2
PreReq:         xml-commons-apis
PreReq:         regexp >= 1.3
# jakarta packages
PreReq:         jakarta-commons-collections >= 2.0
PreReq:         jakarta-commons-beanutils >= 1.4.1
Requires:       jakarta-commons-daemon
PreReq:         jakarta-commons-dbcp >= 1.2.1
PreReq:         jakarta-commons-digester >= 1.3
PreReq:         jakarta-commons-modeler
PreReq:         jakarta-commons-pool >= 1.1
PreReq:         jakarta-commons-logging >= 1.0.4
PreReq:         jakarta-commons-fileupload >= 1.0
Requires:       jakarta-commons-launcher >= 0.9
PreReq:         jakarta-commons-el >= 1.0
PreReq:         jakarta-taglibs-standard >= 1.1.0
Requires:       mx4j >= 1.1.1
# alternatives
PreReq:         jaas, jndi, jndi-ldap, java-devel
# jdbc extension is not available on 64bit platforms
#PreReq:         jdbc-stdext
# non-free stuff
PreReq:         jta >= 1.0.1-0.a.1, jaf >= 1.0.1, javamail >= 1.3
PreReq:         servletapi5 >= 5.0.18
PreReq:         /usr/sbin/useradd, /usr/sbin/groupadd, sed
PreReq:         findutils
BuildRequires:  jpackage-utils >= 1.5.24
Obsoletes:      jakarta-tomcat
Provides:       jakarta-tomcat

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages pecifications are developed by
Sun under the Java Community Process.



Authors:
--------
    Hans Bergsten <hans@gefionsoftware.com>
    James Duncan <Davidson duncan@x180.com>
    Pierpaolo Fumagalli <pier@apache.org>
    Craig McClanahan <cmcclanahan@mytownnet.com>
    Sam Ruby <rubys@us.ibm.com>
    Jon Stevens <jon@clearink.com>
    Anil Vijendran <akv@eng.sun.com>
    Brian Behlendorf <brian@behlendorf.com>
    Kevin Burton <burton@relativity.yi.org>
    Danno Ferrin <shemnon@earthlink.net>
    Jason Hunter <jh@servlets.com>
    Ramesh Mandava <rmandava@talentportal.com>
    Stefano Mazzocchi <stefano@apache.org>
    Rajiv Mordani <mode@chinet.com>
    Harish Prabhandham <harishp@onebox.com>
    Jean-Luc Rochat <shachor@il.ibm.com>
    James Todd <jwtodd@pacbell.net>

%debug_package
%package webapps
License:        BSD 3-Clause; The Apache Software License; X11/MIT; zlib/libpng License
Group:          Productivity/Networking/Web/Frontends
Requires:       %{name} = %{version}-%{release}
Requires:       jakarta-taglibs-standard >= 1.1.0
Summary:        Webapps for tomcat5
Provides:       jakarta-tomcat-examples, jakarta-tomcat-docs
Obsoletes:      jakarta-tomcat-examples, jakarta-tomcat-docs

%description webapps
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages pecifications are developed by
Sun under the Java Community Process.

This package contains the sample webapps for Tomcat.



Authors:
--------
    Hans Bergsten <hans@gefionsoftware.com>
    James Duncan <Davidson duncan@x180.com>
    Pierpaolo Fumagalli <pier@apache.org>
    Craig McClanahan <cmcclanahan@mytownnet.com>
    Sam Ruby <rubys@us.ibm.com>
    Jon Stevens <jon@clearink.com>
    Anil Vijendran <akv@eng.sun.com>
    Brian Behlendorf <brian@behlendorf.com>
    Kevin Burton <burton@relativity.yi.org>
    Danno Ferrin <shemnon@earthlink.net>
    Jason Hunter <jh@servlets.com>
    Ramesh Mandava <rmandava@talentportal.com>
    Stefano Mazzocchi <stefano@apache.org>
    Rajiv Mordani <mode@chinet.com>
    Harish Prabhandham <harishp@onebox.com>
    Jean-Luc Rochat <shachor@il.ibm.com>
    James Todd <jwtodd@pacbell.net>

%package admin-webapps
License:        BSD 3-Clause; The Apache Software License; X11/MIT; zlib/libpng License
Group:          Productivity/Networking/Web/Frontends
PreReq:         %{name} = %{version}-%{release}
PreReq:         struts >= 1.1
Summary:        Admin webapps for tomcat5

%description admin-webapps
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages pecifications are developed by
Sun under the Java Community Process.

This package contains the admin webapps for Tomcat.



Authors:
--------
    Hans Bergsten <hans@gefionsoftware.com>
    James Duncan <Davidson duncan@x180.com>
    Pierpaolo Fumagalli <pier@apache.org>
    Craig McClanahan <cmcclanahan@mytownnet.com>
    Sam Ruby <rubys@us.ibm.com>
    Jon Stevens <jon@clearink.com>
    Anil Vijendran <akv@eng.sun.com>
    Brian Behlendorf <brian@behlendorf.com>
    Kevin Burton <burton@relativity.yi.org>
    Danno Ferrin <shemnon@earthlink.net>
    Jason Hunter <jh@servlets.com>
    Ramesh Mandava <rmandava@talentportal.com>
    Stefano Mazzocchi <stefano@apache.org>
    Rajiv Mordani <mode@chinet.com>
    Harish Prabhandham <harishp@onebox.com>
    Jean-Luc Rochat <shachor@il.ibm.com>
    James Todd <jwtodd@pacbell.net>

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}
%setup -q -c -T -a 0 -b10
cd %{packdname}
# %patch0
%patch1 -p2
%patch2 -p2
# %patch3 -p2 -b .nojsvc
%patch4 -p2 -b .cluster
%patch5 -p2 -b .skip
%patch6 -p0
%patch7 -p0
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12
#%{_bindir}/build_xml_helper -S -T -J -a -d $RPM_BUILD_DIR/build.xml.conf.info
%patch150 -p1
%patch13 -p1
%patch14 -p1
%patch15
%patch16
%patch17
%patch18
cd ..
%patch19
%patch20
%patch21
%patch22
%patch23
%patch24
%patch25
%patch26
%patch27
%patch28

%build
export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2 xalan-j2-serializer)
# Remove pre-build jars
for dir in %{packdname} ; do
    find $dir -name "*.jar" -exec rm -f {} \;
done
pushd %{packdname}
cp $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/LICENSE .
popd 
# build jsp-api, servlet-api as ant dist will later on require them for webapps
pushd jakarta-tomcat-%{version}-src/jakarta-servletapi-5
pushd jsr154
ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
popd
pushd jsr152
ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
popd
popd
# build tomcat 5
pushd %{packdname}/jakarta-tomcat-5
cat >> build.properties <<EOBP
ant.jar=%{_javadir}/ant.jar
ant-launcher.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-connectors/
jasper.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-jasper/jasper2
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-el.jar=$(build-classpath commons-el)
commons-launcher.jar=$(build-classpath commons-launcher)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath jmxri)
jmx-tools.jar=$(build-classpath mx4j/mx4j-tools.jar)
jmxri.jar=$(build-classpath jmxri)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp)
servlet-api.jar=$(build-classpath servletapi5)
jsp-api.jar=$(build-classpath jspapi)
servlet.doc=%{_javadocdir}/servletapi5
struts.jar=$(build-classpath struts)
struts.lib=%{_datadir}/struts
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xml-apis.jar=$(build-classpath xml-commons-apis)
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
servletapi.build.notrequired=true
jspapi.build.notrequired=true
EOBP
if build-classpath jdbc-stdext
then
  echo jdbc20ext.jar=$(build-classpath jdbc-stdext) >> build.properties 
fi
# can't use jikes to build tomcat (strange)
ant -Dbuild.compiler=modern -Djava.home=%{java_home} build 
popd
# build the connectors
pushd %{packdname}/jakarta-tomcat-connectors
# this is just plain and simply evil but something changed in a major way between 5.0.16 and 5.0.18
export CLASSPATH=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar:\
$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/build/server/lib/catalina.jar
cat > build.properties <<EOBP
activation.jar=$(build-classpath jaf)
ant.jar=%{_javadir}/ant.jar
junit.jar=$(build-classpath junit)
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-digester.jar=$(build-classpath commons-digester)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
regexp.jar=$(build-classpath regexp)
jmx.jar=$(build-classpath mx4j/mx4j-jmx)
puretls=$(build-classpath puretls)
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
EOBP
if build-classpath jdbc-stdext
then
  echo jdbc20ext.jar=$(build-classpath jdbc-stdext) >> build.properties
fi
ant -Dbuild.compiler=modern -Djava.home=%{java_home} build dist
popd

%install
rm -rf $RPM_BUILD_ROOT
export CLASSPATH=%(build-classpath xalan-j2-serializer xalan-j2 xml-commons-apis jakarta-taglibs-core jakarta-taglibs-standard jspapi):/usr/share/java-1.4.0/puretls-0.9.b4.jar
# build initial path structure
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_sbindir},%{_sysconfdir}/{init.d,logrotate.d},%{_javadir}}
install -m 755 -d $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
install -m 755 %{SOURCE9} $RPM_BUILD_ROOT/%{bindir}/relink
# sysv init and logging
install addons/rctomcat5 $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
ln -sf %{_sysconfdir}/init.d/tomcat5 $RPM_BUILD_ROOT/usr/sbin/rctomcat5
install -m 644 addons/sysconfig.j2ee-%{name} $RPM_BUILD_ROOT%{_var}/adm/fillup-templates/
# suse documentation
install -m 755 -d $RPM_BUILD_ROOT%{_docdir}/%{name}
install -m 644 addons/README.SuSE $RPM_BUILD_ROOT%{_docdir}/%{name}
#install -m 644 LICENSE *.txt $RPM_BUILD_ROOT%{_docdir}/%{name}
install -m 644 addons/RELEASE-NOTES $RPM_BUILD_ROOT%{_docdir}/%{name}
pushd %{packdname}/jakarta-tomcat-5
export usejikes=false
ant -Dbuild.compiler=modern -Djava.home=%{java_home} dist
pushd dist
    mv bin/*     ${RPM_BUILD_ROOT}%{bindir}
    mv common/*  ${RPM_BUILD_ROOT}%{commondir}
    mv conf/*    ${RPM_BUILD_ROOT}%{confdir}
    mv server/*  ${RPM_BUILD_ROOT}%{serverdir}
    mv shared/*  ${RPM_BUILD_ROOT}%{shareddir}
    mv webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd
popd
#log4j properties file for the tomcat logger
if [ ! -e $RPM_BUILD_ROOT/%{commondir}/classes ]
then
  mkdir -p $RPM_BUILD_ROOT/%{commondir}/classes
fi
install -m 644 addons/log4j.properties $RPM_BUILD_ROOT/%{commondir}/classes
pushd %{packdname}/jakarta-tomcat-5
# Remove leftover files ?
rm -f $RPM_BUILD_ROOT%{bindir}/*.orig
# install logrotate support
install %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
# FHS compliance patches, not easy to track them all boys :)
for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{jname} $RPM_BUILD_ROOT%{_bindir}/%{jname} \
         $RPM_BUILD_ROOT%{bindir}/relink $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}
    do
    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done
### Replace local copies with jpp-compatible links
# Process server/lib
pushd   $RPM_BUILD_ROOT/%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" \
                         -exec rm -f {} \;
    # catalina-ant will be installed in a public repository
    mv catalina-ant.jar $RPM_BUILD_ROOT/%{_javadir}/catalina-ant-%{version}.jar
    pushd $RPM_BUILD_ROOT/%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant5.jar
    popd
popd
# Process admin webapp server/webapps/admin
# don't remove catalina-admin though
pushd $RPM_BUILD_ROOT/%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" -not -name 'catalina-admin*' -exec rm -f {} \;
popd
# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/lib
    find . -name "*.jar" -not -name "jasper*" \
                         -not -name "naming*" \
                         -exec rm -f {} \;
popd
# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
    find . -name "*.jar" -exec rm -f {} \;
popd
# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{commondir}/lib/servlet.jar
# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT%{catalina_base}
    ln -s %{confdir} conf
    ln -s %{logdir}  logs
    ln -s %{workdir} work
    ln -s %{tempdir} temp
    ln -s %{commondir} common
    ln -s %{serverdir} server
popd
pushd $RPM_BUILD_ROOT%{homedir}
   ln -s %{catalina_base}/conf	  conf
   ln -s %{catalina_base}/logs    logs
   ln -s %{catalina_base}/webapps webapps
   ln -s %{catalina_base}/work    work
   ln -s %{catalina_base}/temp    temp
popd
cd $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src
find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | sed s+$RPM_BUILD_ROOT++g > homelinks

%clean
rm -rf $RPM_BUILD_ROOT

%post
### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
for repository in %{serverdir}/lib \
                  %{commondir}/lib \
                  %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
done
build-jar-repository %{serverdir}/lib commons-beanutils commons-fileupload \
                                      commons-digester commons-logging \
                                      commons-modeler commons-el regexp jmxri jaas \
                                      catalina-ant5 2>&1
build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-pool commons-logging-api commons-el\
                                      jaf jta javamail jndi jmxri \
                                      jspapi servletapi5 log4j 2>&1
if ! build-jar-repository %{commondir}/lib jdbc-stdext > /dev/null 2>&1
then
  rm %{commondir}/lib/[jdbc-stdext].jar
fi
# compatibility link for eclipse server runtime check for tomcat
ln -sf %{commondir}/lib/servletapi5.jar $RPM_BUILD_ROOT/%{commondir}/lib/servlet-api.jar
ln -sf %{commondir}/lib/jspapi.jar $RPM_BUILD_ROOT/%{commondir}/lib/jsp-api.jar
build-jar-repository %{commondir}/endorsed jaxp_parser_impl xml-commons-apis 2>&1
# create links without [ ] around the name (needed by some programs (among others an eclipse
# plugin) that test whether the tomcat installation is valid or not)
build-jar-repository -s -p %{serverdir}/lib commons-beanutils commons-fileupload \
                                      commons-digester commons-logging \
                                      commons-modeler commons-el regexp jmxri jaas \
                                      catalina-ant5 2>&1
build-jar-repository -s -p %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-pool commons-logging-api commons-el\
                                      jaf jta javamail jndi jmxri \
                                      jspapi servletapi5 log4j 2>&1
if ! build-jar-repository -s -p %{commondir}/lib jdbc-stdext 2>&1
then
  rm %{commondir}/lib/jdbc-stdext.jar
fi
build-jar-repository -s -p %{commondir}/endorsed jaxp_parser_impl xml-commons-apis 2>&1
# suse specific
if [ -f /etc/sysconfig/j2ee ]
then
# on update from jakarta-tomcat, change CATALINA_HOME if it is set to the 
# old default
sed -i -e s,CATALINA_HOME=\"/usr/share/tomcat\",CATALINA_HOME=\"/usr/share/tomcat5\", /etc/sysconfig/j2ee
fi
%{fillup_and_insserv -f -s tomcat5 START_TOMCAT}
%{fillup_only -a -n -s j2ee %name}

%post webapps 
### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
build-jar-repository %{appdir}/jsp-examples/WEB-INF/lib \
      jakarta-taglibs-core jakarta-taglibs-standard 2>&1

%post admin-webapps
### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java
# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' \
     -not -name 'catalina-admin*' -not -type d -exec rm -f {} \;
build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts 2>&1

%preun
# Always clean up wordir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*
%stop_on_removal tomcat5
if [ $1 = 0 ]; then
    # Remove automated symlinks
    for repository in %{serverdir}/lib \
                      %{commondir}/lib \
                      %{commondir}/endorsed ; do
        find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
    done
fi

%postun
%{insserv_cleanup}

%preun admin-webapps
if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -name 'catalina-admin*' -not -type d -exec rm -f {} \;
fi

%preun webapps
if [ $1 = 0 ]; then
    find %{appdir}/jsp-examples/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -type d -exec rm -f {} \;
fi

%pre
# Add the "tomcat" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -r tomcat 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat" -g tomcat \
    -s /bin/sh -r -d %{homedir} tomcat 2> /dev/null || :
# if updating from something really old:
# save older configuration which could be changed by the user
# (was not marked %config in older package versions by mistake)
for file in `find /opt/jakarta/tomcat/conf/ -type f 2>/dev/null` \
            `find /opt/jakarta/tomcat/server/ /opt/jakarta/tomcat/webapps/ -name "*.xml" -type f 2>/dev/null` ; do
  test "${file%%.rpmsave-by-jakarta-tomcat}" == "$file" && \
  cp -auv "$file" "$file.rpmsave-by-jakarta-tomcat" || true
done

%files 
%defattr(-, root, root)
%dir %{_docdir}/%{name}/
#%{_docdir}/%{name}/LICENSE
%{_docdir}/%{name}/README.SuSE
%{_docdir}/%{name}/RELEASE-NOTES
#%{_docdir}/%{name}/*.txt
%{_sysconfdir}/init.d/tomcat5
%config %{_sysconfdir}/logrotate.d/tomcat5
/usr/sbin/rctomcat5
%dir %{_datadir}/tomcat5
# true directories
%dir %{_datadir}/tomcat5/bin
%attr(0755,root,root) %{_datadir}/tomcat5/bin/*
%{_datadir}/tomcat5/common
%dir %{_datadir}/tomcat5/server
%{_datadir}/tomcat5/server/lib
%{_datadir}/tomcat5/shared
# symlinks
%{_datadir}/tomcat5/conf
%{_datadir}/tomcat5/logs
%{_datadir}/tomcat5/temp
%dir %{_datadir}/tomcat5/webapps
%{_datadir}/tomcat5/work
# ant tasks
/usr/share/java/catalina-ant-%{version}.jar
/usr/share/java/catalina-ant5.jar
%dir /srv/www/tomcat5/
/srv/www/tomcat5/base/common
/srv/www/tomcat5/base/server
%dir %attr(-, tomcat, tomcat) %{catalina_base}
%dir %attr(-, tomcat, tomcat) %{appdir}
%{catalina_base}/logs
%{catalina_base}/conf
%{catalina_base}/work
%{catalina_base}/temp
%dir %{_sysconfdir}/tomcat5/
%defattr(-, tomcat, tomcat)
%dir %{_sysconfdir}/tomcat5/base/
%config %{_sysconfdir}/tomcat5/base/catalina.policy
%config %{_sysconfdir}/tomcat5/base/catalina.properties
%config %{_sysconfdir}/tomcat5/base/jk2.properties
%config %{_sysconfdir}/tomcat5/base/server-minimal.xml
%config %{_sysconfdir}/tomcat5/base/server.xml
%config %{_sysconfdir}/tomcat5/base/tomcat-users.xml
%config %{_sysconfdir}/tomcat5/base/web.xml
%config %dir %{_sysconfdir}/tomcat5/base/Catalina
%config %dir %{_sysconfdir}/tomcat5/base/Catalina/localhost
%defattr(-, root, root)
#%config %attr(-, tomcat, tomcat) %{_sysconfdir}/tomcat5/base/*
%dir %{_var}/log/tomcat5/
%attr(-, tomcat, tomcat) %{_var}/log/tomcat5/base
%dir %{_var}/cache/tomcat5/
%attr(-, tomcat, tomcat) %{_var}/cache/tomcat5/base
%{_var}/adm/fillup-templates/*

%files webapps
%defattr(644,root,tomcat,775)
%dir %{appdir}/servlets-examples
%{appdir}/servlets-examples/*
%dir %{appdir}/jsp-examples
%{appdir}/jsp-examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*

%files admin-webapps
%defattr(640,root,tomcat,750)
%doc addons/README
%attr(660,root,tomcat) %{confdir}/Catalina/localhost/manager.xml
%{confdir}/Catalina/localhost/balancer.xml
%{confdir}/Catalina/localhost/admin.xml
%dir %{appdir}/balancer
%{appdir}/balancer/*
%dir %{serverdir}/webapps
%{serverdir}/webapps/*

%changelog
* Wed Oct 15 2008 - mvyskocil@suse.cz
- fix of CVE-2008-3271: bnc#435145 - VUL-0: tomcat5: bypass filter
  - http://svn.apache.org/viewvc?view=rev&revision=303161
* Tue Aug 19 2008 - mvyskocil@suse.cz
- fix CVE-2008-2938: VUL-0: tomcat5: directory traversal
* Tue Aug 05 2008 - mvyskocil@suse.cz
- fix CVE-2008-1232 and CVE-2008-2370: VUL-0: Apache Tomcat Cross-Site
  Scripting and Security Bypass [bnc#414657]
* Tue Mar 04 2008 - mvyskocil@suse.cz
- fix CVE-2007-2450: VUL-0: more tomcat XSS's [bnc#292414]
- fix CVE-2007-2449: VUL-0: more tomcat XSS's [bnc#292414]
  partially included in fix of CVE-2006-7196
- fix CVE-2007-1859: VUL-0: tomcat: bad SSL cipher usage
  [#bnc274242]
* Tue Feb 19 2008 - mvyskocil@suse.cz
- fix the CVE-2007-5333: Tomcat Cookie handling vulnerabilities
  [bnc#360502]
* Mon Feb 04 2008 - mvyskocil@suse.cz
- fix the CVE-2008-0128: tomcat https information disclosure
  [bnc#355046]
- fix the CVE-2005-2090: tomcat HTTP Request Smuggling [bnc#352839]
* Wed Dec 12 2007 - skh@suse.de
- fix CVE-2006-7196: Cross-site scripting (XSS) vulnerability in
  example JSP applications [bnc #307619]
- fix CVE-2007-3382: Handling of cookies containing a ' character
  [#300586]
- fix CVE-2007-3385: Handling of \" in cookies [#300588]
- fix CVE-2007-5461: tomcat path traversal / information leak [bnc
  [#334476]]
* Tue May 15 2007 - dbornkessel@suse.de
- bug fix for Bug #274237
  http://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2006-7195
  Cross-site scripting (XSS) vulnerability in implicit-objects.jsp in
  Apache Tomcat 5.0.0 through 5.0.30 and 5.5.0 through 5.5.17 allows
  remote attackers to inject arbitrary web script or HTML via certain
  header values.
* Tue Mar 20 2007 - dbornkessel@suse.de
- backported security fix (Bug #254482)
  CVE-2007-0450
  Tomcat permits both '\' and '%%5C' as path delimiters. A HTTP request containing strings like "/\../"
  allow attackers to break out of the given context. Additionally, when using Tomcat behind a proxy
  configured to only proxy some contexts this permits access to non-proxied contexts. When used
  behind a proxy it is recommended that Tomcat is secured as if the proxy were not present.
  The following Java startup options have been added to Tomcat to provide additional control of the handling of '\' and '%%5c' in URLs:
  * -Dorg.apache.tomcat.util.buf.UDecoder.ALLOW_ENCODED_SLASH=true|false
  * -Dorg.apache.catalina.connector.CoyoteAdapter.ALLOW_BACKSLASH=true|false
  These options default to false.
* Fri Sep 22 2006 - dbornkessel@suse.de
- set source=1.4 for java and fix code ambiguity (cf. bsc#4983021)
* Thu Aug 17 2006 - dbornkessel@suse.de
- added docu for admin-webapps package
- repackaged addons as bz2 archive
* Tue Jul 04 2006 - dbornkessel@suse.de
- added jsp-api.jar -> jspapi.jar link for compatibility reasons
  thanks to Roman Asendorf for pointing that out
* Wed Jun 21 2006 - dbornkessel@suse.de
- added 'findutils' to the PreReq list, as 'find' is used in %%preun
* Wed Apr 19 2006 - dbornkessel@suse.de
- removed jdbc as PreReq as it is not provided on all plattforms.
  Instead, links and build properties for jdbc are only created
  when jdbc is really there (Bug #164836)
* Mon Mar 27 2006 - dbornkessel@suse.de
- link /usr/share/tomcat5/common/lib/servletapi5.jar -> /usr/share/tomcat5/common/lib/servlet-api.jar
  for eclipse server runtime verification script (Bug #160769)
* Tue Mar 21 2006 - dbornkessel@suse.de
- amended startup script for correct shutdown (Bug #157069)
* Wed Mar 15 2006 - dbornkessel@suse.de
- replaced test -n  $JAVA_OPTS
  with     test -n "$JAVA_OPTS"
* Fri Mar 10 2006 - dbornkessel@suse.de
- added symlinks to tomcat in order to be recognized by some programs (i.e. eclipse)
  as a valid tomcat installation (Bug #134338)
- added more variables to /etc/sysconfig/j2ee
- sysconfig allows now to set the user & group with which to run tomcat
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Wed Nov 23 2005 - dbornkessel@suse.de
- changed logrotate conf file and tomcat logger configuration / Bug #118763
- changed rctomcat5 script as proposed in Bug #134572
- fixed bug in struts config
- patched catalina.sh to have a work around if JAVA_HOME is wrong / Bug #129641
- added log4j.properties for tomcat
- added creation to log4j package in common/lib dir / Bug #113701
- added log4j as a requirement as it is used by tomcat
* Thu Sep 29 2005 - dmueller@suse.de
- add norootforbuild
* Thu Sep 01 2005 - skh@suse.de
- fix struts-config.xml in admin webapp (#113319)
* Fri Mar 04 2005 - skh@suse.de
- remove superfluous %%defines
* Tue Feb 22 2005 - skh@suse.de
- update to version 5.0.30
- fix build with current struts
* Mon Feb 21 2005 - skh@suse.de
- update to version 5.0.28
* Fri Oct 01 2004 - skh@suse.de
- Fix %%files section breakage from last change (#46620)
- Fix documentation (#46599)
* Wed Sep 29 2004 - skh@suse.de
- Fix %%files section to remove file conflicts between main package and
  subpackages.
* Mon Sep 27 2004 - skh@suse.de
- Set CATALINA_HOME in /etc/sysconfig/j2ee correctly when updating from
  jakarta-tomcat (#46080)
* Fri Sep 17 2004 - skh@suse.de
- Create correct and backwards-compatible directory and symlink
  structure (#45503)
- really fix prerequires
* Thu Sep 16 2004 - skh@suse.de
- Use SUSE config files and rc scripts following the old
  jakarta-tomcat package
- fix prerequires
* Mon Sep 13 2004 - skh@suse.de
- Be FHS compliant again (install below /srv/www/tomcat5 instead
  of /var/lib/tomcat5)
- Fix Provides and Obsoletes
* Tue Sep 07 2004 - skh@suse.de
- Fix PreRequires.
* Mon Sep 06 2004 - skh@suse.de
- ... and use correct file permissions.
* Mon Sep 06 2004 - skh@suse.de
- Don't use fixed uid/gid
* Mon Sep 06 2004 - skh@suse.de
- Switched to JPackage version with 5.0.27 (JPackage 1.5)
